/*
** Module   : SaxReaderImpl
** Abstract : SAX reader specific features implementation.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------------------Description----------------------------------
** 001 EVL 20130208 Created initial version. Implementation is limited to the stubs to get the
**                  converted java code compiled.
** 002 CA  20130221 Added ADM-DATA and UNIQUE-ID support. 
*/

package com.goldencode.p2j.xml;

import com.goldencode.p2j.util.*;

/**
 * Implementation SAX-Reader specific features of the SAX objects.
 */
public class SaxReaderImpl
extends SaxEntityImpl
implements SaxReader
{
   // Attributes
   /**
    * Gets the value of the handler atribute for the given SAX Reader object.
    * 
    * @return   The handle variable representing the handler attribute.
    */
   public handle getHandler()
   {
      // TODO:
      return new handle();
   }

   /**
    * Sets the value of the handler atribute for the given SAX Reader object.
    * 
    * @param    hCallback
    *           The handle of the new callback handler to be set for the handler attribute.
    */
   public void setHandler(handle hCallback)
   {
      // TODO:
      return;
   }
   
   /**
    * Gets the value of the current 1-based column in XML source.
    * 
    * @return   The integer value of the current column.
    */
   public integer getLocatorColumnNumber()
   {
      // TODO:
      return new integer();
   }

   /**
    * Gets the value of the current 1-based line number in XML source.
    * 
    * @return   The integer value of the current line.
    */
   public integer getLocatorLineNumber()
   {
      // TODO:
      return new integer();
   }
   
   /**
    * Gets the current value of the parse status. The default value is {@link #SAX_UNINITIALIZED}.
    * The other returned values are {@link #SAX_COMPLETE}, {@link #SAX_PARSER_ERROR} or 
    * {@link #SAX_RUNNING}.
    * 
    * @return   The integer value representing the current status of the parse.
    */
   public integer getParseStatus()
   {
      // TODO:
      return new integer();
   }

   /**
    * Gets the current value of the public identifier of the current XML source.
    * 
    * @return   The character value representing the current locator-public-id attribute.
    */
   public character getLocatorPublicId()
   {
      // TODO:
      return new character();
   }

   /**
    * Gets the current value of the system identifier of the current XML source.
    * 
    * @return   The character value representing the current locator-system-id attribute.
    */
   public character getLocatorSystemId()
   {
      // TODO:
      return new character();
   }
   
   /**
    * Gets the current value of the namespace location pair mapping.
    * 
    * @return   The character value representing the current schema-location attribute.
    */
   public character getSchemaLocation()
   {
      // TODO:
      return new character();
   }
   
   /**
    * Sets the current value of the namespace location pair mapping.
    * 
    * @param    location
    *           The new value the current schema-location attribute.
    */
   public void setSchemaLocation(character location)
   {
      // TODO:
      return;
   }
   
   /**
    * Sets the current value of the namespace location pair mapping.
    * 
    * @param    location
    *           The new value the current schema-location attribute.
    */
   public void setSchemaLocation(String location)
   {
      setSchemaLocation(new character(location));
   }
   
   /**
    * Gets the delimiter separated list of directory paths used to locate XML DTD associated with
    * a particular XML document.
    * 
    * @return   The character value representing the current schema-path attribute.
    */
   public character getSchemaPath()
   {
      return new character();
   }
   
   /**
    * Sets the delimiter separated list of directory paths used to locate XML DTD associated with
    * a particular XML document.
    * 
    * @param    path
    *           The new value the current schema-path attribute.
    */
   public void setSchemaPath(character path)
   {
      // TODO:
      return;
   }
   
   /**
    * Sets the delimiter separated list of directory paths used to locate XML DTD associated with
    * a particular XML document.
    * 
    * @param    path
    *           The new value the current schema-path attribute.
    */
   public void setSchemaPath(String path)
   {
      setSchemaPath(new character(path));
   }
   
   /**
    * Indicates if the namespace processing is suppressed or not.
    * 
    * @return   The logical value representing the current suppress-namespace-processing
    *           attribute.
    */
   public logical getSuppressNamespaceProcessing()
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Redefines whether the namespace processing is suppressed or not.
    * 
    * @param    suppress
    *           The new value the current suppress-namespace-processing attribute.
    */
   public void setSuppressNamespaceProcessing(logical suppress)
   {
      // TODO:
      return;
   }
   
   /**
    * Redefines whether the namespace processing is suppressed or not.
    * 
    * @param    suppress
    *           The new value the current suppress-namespace-processing attribute.
    */
   public void setSuppressNamespaceProcessing(boolean suppress)
   {
      setSuppressNamespaceProcessing(new logical(suppress));
   }
   
   /**
    * Indicates if the parser validates the XML document against DTD or not.
    * 
    * @return   The logical value representing the current validation-enabled attribute.
    */
   public logical getValidationEnabled()
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Redefines whether the parser will validate the XML document against DTD or not.
    * 
    * @param    enable
    *           The new value the current validation-enabled attribute.
    */
   public void setValidationEnabled(logical enable)
   {
      // TODO:
      return;
   }
   
   /**
    * Redefines whether the parser will validate the XML document against DTD or not.
    * 
    * @param    enable
    *           The new value the current validation-enabled attribute.
    */
   public void setValidationEnabled(boolean enable)
   {
      setValidationEnabled(new logical(enable));
   }
   
   // Methods
   /**
    * Executing single call parse of an XML document associated with a SAX-Reader object.
    */
   public void saxParse()
   {
      // TODO:
      return;
   }

   /**
    * Initializes and begins progressice-scan parse of an XML document associated with a
    * SAX-Reader object.
    */
   public void saxParseFirst()
   {
      // TODO:
      return;
   }

   /**
    * Continues progressice-scan parse of an XML document associated with a SAX-Reader object.
    */
   public void saxParseNext()
   {
      // TODO:
      return;
   }

   /**
    * Specifies the input source of the XML document to be parsed by a SAX-Reader object.
    * 
    * @param    mode
    *           The type of the object to process. Can be 'FILE', 'HANDLE', 'MEMPTR' or
    *           'LONGCHAR'.
    * @param    source
    *           The appropriate object to process.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical setInputSource(String mode, Object source)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Specifies the input source of the XML document to be parsed by a SAX-Reader object.
    * 
    * @param    mode
    *           The type of the object to process. Can be 'FILE', 'HANDLE', 'MEMPTR' or
    *           'LONGCHAR'.
    * @param    source
    *           The appropriate object to process.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical setInputSource(character mode, Object source)
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Causes parser to stop parsing the XML document.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical stopParsing()
   {
      // TODO:
      return new logical(true);
   }

   /**
    * Gets the the unique ID number associated to this object by the underlying system. Not the 
    * same as the handle value itself.
    * 
    * @return   The integer number of the children.
    */
   @Override
   public integer getUniqueID()
   {
      // TODO Auto-generated method stub
      return null;
   }

   /**
    * Get the value of the ADM-DATA attribute.
    * 
    * @return   See above.
    */
   @Override
   public character getADMData()
   {
      // TODO Auto-generated method stub
      return null;
   }

   /**
    * Set the value of the ADM-DATA attribute.
    * 
    * @param    value
    *           The new value.
    */
   @Override
   public void setADMData(String value)
   {
      // TODO Auto-generated method stub
   }

   /**
    * Set the value of the ADM-DATA attribute.
    * 
    * @param    value
    *           The new value.
    */
   @Override
   public void setADMData(character value)
   {
      // TODO Auto-generated method stub
   }
}
